#include <stdio.h>
#include <time.h>

/* dossetc.c */
/* program to convert an .exe file of downloaded code
	to the proper format for downloading -- crc version */

#define VERSION "1.00"

#define BSIZE 60000
char buf[BSIZE];

long timer;

long searchn ();

main (argc, argv)
int argc;
char **argv;

{
	FILE *infile;
	FILE *outfile;
	long i, k;
	long sizer, beg, end;
	long off;
	long got, j;
	char sbeg[100], send[100];
	long nbytes, nblocks;
	unsigned short crc;
	char val;

	time (&timer);
	printf ("dossetc -- version %s\n", VERSION);
	if (argc != 3)
	{
usage:
		printf ("\n\007Usage -- dosset in-filename out-filename\n");
		exit (1);
	}
	infile = fopen (argv[1], "rb");
	if (infile == NULL)
	{
		printf ("\n\007Error -- can't open input file %s\n", argv[1]);
		exit (1);
	}
	outfile = fopen (argv[2], "wb");
	if (outfile == NULL)
	{
		printf ("\n\007Error -- can't open output file %s\n", argv[2]);
		exit (1);
	}
	sizer = 0;
	off = 0;
	while (1)
	{
		if (off >= BSIZE - 1005)
		{
			printf ("Input file too big\n");
			exit (1);
		}
		got = fread (&buf[off], 1, 1000, infile);
		off += got;
		sizer += got;
		if (got != 1000)
			break;
	}
	strcpy (sbeg, "BeGiNnInG oF cOdE");
	strcpy (send, "eNd Of CoDe");
	beg = searchn (buf, sbeg, sizer);
	end = searchn (buf, send, sizer+1);
	if (beg == -1 || end == -1 || end <= beg)
	{
		printf ("\n\007Error -- can't located beginning and/or ending marker\n");
		exit (1);
	}
	beg -= 51;	/* 16 header bytes plus 3-byte jump plus 32 for date
			& etc. */
	if (beg < 0)
	{
		printf ("\n\007Error -- marker too close to beginning of file\n");
		exit (1);
	}
	nbytes = end - beg + strlen (send);
	if ((nbytes % 512) != 0)
		nbytes += 512;
	nblocks = nbytes / 512;
	buf[beg] = 0x3c;	//magic number
	buf[beg+1] = nblocks - 1;	/* number of additional 1K blocks */
	strcpy (&buf[beg+16], ctime (&timer));
	buf[beg+40] = 0;	/* get rid of newline */
	crc = 0xffff;
	for (i=beg+4; i<beg+nblocks*512; i++)	//accumulate crc byte at a time
	{
		val = buf[i];
		_asm
		{
			pushf
			cli
			pusha
			mov al,val
			mov cx,8			;initialize bit counter
			mov bx,crc

xcrc01:
			xor dl,dl
			shl bx,1			;double CRC word
			rcl dl,1			;save carry in DL
			shl al,1			;test MSB of character
			jnc xcrc02			;skip if not set
			or bx,1

xcrc02:
			or dl,dl			;check carry on CRC
			jz xcrc03			;skip if not set
			xor bx,1021h		;xor with polynomial

xcrc03:
			loop xcrc01
			mov crc,bx
			popa
			popf
		}
	}
	buf[beg+2] = crc & 0xff;	//low byte of crc
	buf[beg+3] = (crc >> 8) & 0xff;
	off = beg;
	for (i=0; i<nblocks; i++)
	{
		j = fwrite (&buf[off], 1, 512, outfile);
		if (j != 512)
		{
			printf ("\n\007Error -- cant write the whole file\n");
			exit (1);
		}
		off += 512;
	}
	exit (0);
}

long searchn (buffer, string, sizer)
char *buffer;
char *string;
long sizer;
{
	long i, j;

	i = strlen (string);
	for (j=0; j<sizer-i; j++)
	{
		if (memcmp (buffer, string, i) == 0)
			return j;
		buffer++;
	}
	return -1;
}
