page	60,132
title	(C) 1991 Computone Corporation -- fifom.asm

;******************************************************************************
;*                                                                            *
;*                                                                            *
;*                                                                            *
;*                  (C) Copyright 1991 Computone Corporation                  *
;*                                                                            *
;*          Unauthorized use, duplication, or disclosure prohibited           *
;*                                                                            *
;*              This module contains PROPRIETARY INFORMATION of               *
;*                            Computone Corporation                           *
;*                   and should be treated as CONFIDENTIAL.                   *
;*                                                                            *
;*                                                                            *
;*                                                                            *
;******************************************************************************
;----------------------------------------------------------
; fifoi.asm
; To support local loopback test:
; Reads fifo data (in native mode) and checks integrity.
; 
; If an error is encountered, it loops the data back,
; then hits the mailbox with 10h if the low byte was bad,
; 20h if high byte was bad, or 30h if both were bad.
; (Cannot use low bits: the II-EX has only the top 6)
;----------------------------------------------------------

VERSION		equ	1
REVISION	equ	0
SUBREVISION	equ	1

;----------------------------------------------------------
; Revision History:
;
;1.0.0 -- 6/6/91 -- first edition
;1.0.1 -- 10/30/91	MAG	Revised to support II/IIEX
;----------------------------------------------------------

include lw_h1.inc


	; Long-term register usage:
	; bh = operating mode (expandable, non-expandable)
	; bl = LED color
	; si = current value to get

	; Formula is value(0) = 0xface;
	; value(i+1) = value(i) + 0x2211;


initialization:

	cli
	cld

	mov	bl, YELLOW
	TOGGLE_LED	bl	; will toggle to green before display

	xor	ax, ax
	mov	ds, ax
	GET_OPERATING_MODE	; Are we expandable or non-expandable?
	mov	bh, al		; Store mode in bh 

	mov	si, 0faceh	

next_char:
	READ_DATA_WORD bh
	mov	cx, ax
	WRITE_DATA_WORD	bh		; assumes fifo must be available.
	cmp	cx, si
	jne	error_hit
	add	si, 2211h

	READ_DATA_WORD bh
	mov cx, ax
	WRITE_DATA_WORD bh
	cmp	cx, si
	jne	error_hit
	add	si, 2211h

	jmp	next_char

error_hit:		; value we read is in cx
	mov	ax, si
	mov	dl, 30h
	cmp	al, cl
	jne	low_diff
	and	dl, not 10h	; low bytes matched
low_diff:
	cmp	ah, ch
	jne	high_diff
	and	dl, not 20h	; high bytes matched
high_diff:
	 
	mov	cl, dl
	HIT_MAILBOX	bh, cl	; Write immediately to output mailbox.
				; we will assume our output mailbox is
				; free. 

	DEAD_RED

include lw_h2.inc	

