page	60,132
title	(C) 1991 Computone Corporation -- fifol.asm

;******************************************************************************
;*                                                                            *
;*                                                                            *
;*                                                                            *
;*                  (C) Copyright 1991 Computone Corporation                  *
;*                                                                            *
;*          Unauthorized use, duplication, or disclosure prohibited           *
;*                                                                            *
;*              This module contains PROPRIETARY INFORMATION of               *
;*                            Computone Corporation                           *
;*                   and should be treated as CONFIDENTIAL.                   *
;*                                                                            *
;*                                                                            *
;*                                                                            *
;******************************************************************************

VERSION		equ	1
REVISION	equ	0
SUBREVISION	equ	1
	;version number information

;1.0.0 -- 6/6/91 -- first edition
;1.0.1 -- 10/29/91 -- Revising for II/IIEX support

include lw_h1.inc

initialization:

	mov	bl, YELLOW
	TOGGLE_LED	bl	; Toggles to green before writing

	cli
	cld

	mov ax,cs		;set all seg registers to the code space
	mov ds,ax
	mov es,ax
	mov ss,ax

	;"local" fifo loopback
	;no stack used
	; LED stays green as we loop back!
	; This tries to be fast.
	; Note that we will always loop back words here.
	; on 8-bit boards, the top byte is don't care, anyway.

	mov	bx, FIFO_DATA	; Commonly used values in registers
	mov	di, FIFO_CMD
	mov	dx, di
	mov	cl, EMPT

wait_1:
	in	al, dx
	test	al, cl
	jnz	wait_1

	mov	dx, bx	; set to data port
	in	ax, dx
	out	dx, ax	
	mov	dx, di	; reset to command port
			; -- unwind the loop for speed!
			; -- if host sent 4 in a row, we take no jumps
	in	al, dx
	test	al, cl
	jnz	wait_1	; Each failure resets us to the top of the loop...

	mov	dx, bx	; set to data port
	in	ax, dx
	out	dx, ax	
	mov	dx, di	; reset to command port

	in	al, dx
	test	al, cl
	jnz	wait_1

	mov	dx, bx	; set to data port
	in	ax, dx
	out	dx, ax	
	mov	dx, di	; reset to command port

	in	al, dx
	test	al, cl
	jnz	wait_1

	mov	dx, bx	; set to data port
	in	ax, dx
	out	dx, ax	
	mov	dx, di	; reset to command port

	jmp wait_1
	
include lw_h2.inc

