page	60,132
title	(C) 1991 Computone Corporation -- fifom.asm

;******************************************************************************
;*                                                                            *
;*                                                                            *
;*                                                                            *
;*                  (C) Copyright 1991 Computone Corporation                  *
;*                                                                            *
;*          Unauthorized use, duplication, or disclosure prohibited           *
;*                                                                            *
;*              This module contains PROPRIETARY INFORMATION of               *
;*                            Computone Corporation                           *
;*                   and should be treated as CONFIDENTIAL.                   *
;*                                                                            *
;*                                                                            *
;*                                                                            *
;******************************************************************************
;----------------------------------------------------------
; fifom.asm
; To support mailbox loopback test:
; reads the mailbox register and writes it back.
;----------------------------------------------------------

VERSION		equ	1
REVISION	equ	0
SUBREVISION	equ	1

;----------------------------------------------------------
; Revision History:
;
;1.0.0 -- 6/6/91 -- first edition
;1.0.1 -- 10/30/91	MAG	Revised to support II/IIEX
;1.0.2 -- 3/24/92   MAG Revised to complement data (i2diag changed also)
;----------------------------------------------------------

include lw_h1.inc


	; Long-term register usage:
	; bh = operating mode (expandable, non-expandable)
	; bl = LED color
	; cl = stores the mailbox value

initialization:

	cli
	cld

	mov	bl, YELLOW
	TOGGLE_LED	bl	; will toggle to green before display

	xor	ax, ax
	mov	ds, ax
	GET_OPERATING_MODE	; Are we expandable or non-expandable?
	mov	bh, al		; Store mode in bh 

wait_1:
	WAIT_FOR_MAILBOX_IN bh	; waits until there is something in the
				; mailbox, then returns it in al
	mov	cl, al
	not cl
	HIT_MAILBOX	bh, cl	; Write immediately to output mailbox.
				; we will assume our output mailbox is
				; free.  Why did the host write a new
				; value if he didn't read the old one
				; yet?
	
	TOGGLE_LED	bl	; green, yellow, green, yellow...

	jmp wait_1

include lw_h2.inc	

