/*--------------------
 * i2bdump.c
 * Routine to dump (printf) contents of
 * the board structure
 *---------------------
 */

#include <stdio.h>
#include "i2ellis.h"
#include "i2lib.h"

void bdump(register i2eBordStrPtr pB)
{
register int i;

	printf("i2ePom.e.porMagic1   = %4x ", pB->i2ePom.e.porMagic1);
	printf("i2ePom.e.porMagic2   = %4x \n", pB->i2ePom.e.porMagic2);
	printf("i2ePom.e.porVersion  = %4x ", pB->i2ePom.e.porVersion);
	printf("i2ePom.e.porRevision = %4x \n", pB->i2ePom.e.porRevision);
	printf("i2ePom.e.porSubRev   = %4x ", pB->i2ePom.e.porSubRev);
	printf("i2ePom.e.porID       = %4x \n", pB->i2ePom.e.porID);
	printf("i2ePom.e.porBus      = %4x ", pB->i2ePom.e.porBus);
	printf("i2ePom.e.porMemory   = %4x \n", pB->i2ePom.e.porMemory);
	printf("i2ePom.e.porPorts1   = %4x ", pB->i2ePom.e.porPorts1);
	printf("i2ePom.e.porDiag1    = %4x \n", pB->i2ePom.e.porDiag1);
	printf("i2ePom.e.porDiag2    = %4x ", pB->i2ePom.e.porDiag2);
	printf("i2ePom.e.porSpeed    = %4x \n", pB->i2ePom.e.porSpeed);
	printf("i2ePom.e.porFlags    = %4x ", pB->i2ePom.e.porFlags);
	printf("i2ePom.e.porPorts2   = %4x \n", pB->i2ePom.e.porPorts2);
	printf("i2ePom.e.porFifoSize = %4x ", pB->i2ePom.e.porFifoSize);
	printf("i2ePom.e.porNumBoxes = %4x \n", pB->i2ePom.e.porNumBoxes);

	printf("i2ePomSize        = %4x ", pB->i2ePomSize);
	printf("i2eStartMail      = %4x \n", pB->i2eStartMail);
	printf("i2eValid          = %4x ", pB->i2eValid);
	printf("i2eError          = %4x \n", pB->i2eError);
	printf("i2eFifoSize       = %4x ", pB->i2eFifoSize);
	printf("i2eFifoRemains    = %4x \n", pB->i2eFifoRemains);
	printf("i2eFifoStyle      = %4x ", pB->i2eFifoStyle);
	printf("i2eDataWidth16    = %4x \n", pB->i2eDataWidth16);
	printf("i2eMaxIrq         = %4x ", pB->i2eMaxIrq);
	printf("i2eChangeIrq      = %4x \n", pB->i2eChangeIrq);
	printf("i2eBase           = %4x ", pB->i2eBase);
	printf("i2eData           = %4x \n", pB->i2eData);
	printf("i2eStatus         = %4x ", pB->i2eStatus);
	printf("i2ePointer        = %4x \n", pB->i2ePointer);
	printf("i2eXMail          = %4x ", pB->i2eXMail);
	printf("i2eXMask          = %4x \n", pB->i2eXMask);
	printf("i2eDelay          = %4x ", pB->i2eDelay);
	printf("i2eWriteBuf       = %4x \n", pB->i2eWriteBuf);
	printf("i2eReadBuf        = %4x ", pB->i2eReadBuf);
	printf("i2eReadWord       = %4x \n", pB->i2eReadWord);
	printf("i2eWriteWord      = %4x ", pB->i2eWriteWord);
	printf("i2eWaitForTxEmpty = %4x \n", pB->i2eWaitForTxEmpty);
	printf("i2eTxMailEmpty    = %4x ", pB->i2eTxMailEmpty);
	printf("i2eTrySendMail    = %4x \n", pB->i2eTrySendMail);
	printf("i2eGetMail        = %4x ", pB->i2eGetMail);
	printf("i2eEnableMailIrq  = %4x \n", pB->i2eEnableMailIrq);
	printf("i2eToLoad         = %4x \n", pB->i2eToLoad);
	printf("i2eState          = %4x ", pB->i2eState);
	printf("i2eLVersion       = %4x \n", pB->i2eLVersion);
	printf("i2eLRevision      = %4x ", pB->i2eLRevision);
	printf("i2eLSub           = %4x \n", pB->i2eLSub);
	printf("i2eUsingIrq       = %4x ", pB->i2eUsingIrq);
	printf("i2eWaitingFor...  = %4x \n", pB->i2eWaitingForEmptyFifo);
	printf("i2eOutMailWaiting = %4x ", pB->i2eOutMailWaiting);
	printf("i2eChannelPtr     = %4x \n", pB->i2eChannelPtr);
	printf("i2eChannelCnt     = %4x ", pB->i2eChannelCnt);
	printf("i2eLeadoffWord[0] = %4x \n", pB->i2eLeadoffWord[0]);
	printf("i2eFifoOutInts    = %4x ", pB->i2eFifoOutInts);
	printf("i2eFifoInInts     = %4x \n", pB->i2eFifoInInts);
	printf("i2fbufStrip       = %4x ", pB->i2fbufStrip);
	printf("i2fbufStuff       = %4x \n", pB->i2fbufStuff);
	printf("i2dbufStrip       = %4x ", pB->i2dbufStrip);
	printf("i2dbufStuff       = %4x \n", pB->i2dbufStuff);
	printf("i2bbufStrip       = %4x ", pB->i2bbufStrip);
	printf("i2bbufStuff       = %4x \n", pB->i2bbufStuff);
	printf("\n");

	for (i = 0; i < CH_QUEUE_SIZE; i++)
	{
		printf("%4x : i2dBuf %4x , i2bBuf %4x, i2fBuf %4x \n",
			i, pB->i2dBuf[i], pB->i2bBuf[i], pB->i2fBuf[i]);
	}
	for (i = 0; i < ABS_MAX_BOXES; i++)
	{
		printf("%4x  Chan = %4x, Good = %4x\n",
			i, pB->i2eChannelMap[i], pB->i2eGoodMap[i]);
	}
}


void cdump(register i2ChanStrPtr pCh)
{
register int i;
register char *pChar;

	printf("validity           = %4x ", pCh->validity);
	printf("pMyBord            = %4x \n", pCh->pMyBord);
	pChar = (char *)(&(pCh->infl));
	printf("infl = %x %x %x %x %x %x %x\n",
		pChar[0], pChar[1], pChar[2], pChar[3], pChar[4], pChar[5], pChar[6]);
		
	printf("infl.hd.i2sChannel = %4x ", pCh->infl.hd.i2sChannel);
	printf("infl.hd.i2sCount   = %4x \n", pCh->infl.hd.i2sCount);
	printf("infl.hd.i2sType    = %4x ", pCh->infl.hd.i2sType);
	printf("infl.fcmd          = %4x \n", pCh->infl.fcmd);
	printf("infl.asof          = %4x ", pCh->infl.asof);
	printf("infl.room          = %4x \n", pCh->infl.room);
	printf("sinceLastFlow      = %4x ", pCh->sinceLastFlow);
	printf("whenSendFlow       = %4x \n", pCh->whenSendFlow);
	printf("channelNeeds       = %4x ", pCh->channelNeeds);
	printf("outfl.asof         = %4x \n", pCh->outfl.asof);
	printf("outfl.room         = %4x ", pCh->outfl.room);
	printf("dataSetIn          = %4x \n", pCh->dataSetIn);
	printf("hotKeyIn           = %4x ", pCh->hotKeyIn);
	printf("bookMarks          = %4x \n", pCh->bookMarks);
	printf("channelOptions     = %4x ", pCh->channelOptions);
	printf("\n");

	printf("ibufStuff = %4x, ibufStrip = %4x\n", 
		pCh->ibufStuff, pCh->ibufStrip);
	printf("ibuf = ");
	for (i = 0; i < IBUF_SIZE + 2; i++)
	{
		if (!(i & 7)) printf("\n");
		printf("%4x ", pCh->ibuf[i]);
	}
	printf("\n");
		
	printf("obufStuff = %4x, obufStrip = %4x\n", 
		pCh->obufStuff, pCh->obufStrip);
	printf("obuf = ");
	for (i = 0; i < OBUF_SIZE+MAX_OBUF_BLOCK+4; i++)
	{
		if (!(i & 7)) printf("\n");
		printf("%4x ", pCh->obuf[i]);
	}
	printf("\n");
		
	printf("cbufStuff = %4x, cbufStrip = %4x\n", 
		pCh->cbufStuff, pCh->cbufStrip);
	printf("cbuf = ");
	for (i = 0; i < CBUF_SIZE+MAX_CBUF_BLOCK+2; i++)
	{
		if (!(i & 7)) printf("\n");
		printf("%4x ", pCh->cbuf[i]);
	}
	printf("\n");
}
		
