/* i2ctest.c 
 * To test all the macros in i2cmd.h
 */

#include "i2cmd.h"

cmdSyntaxPtr r1(cmdSyntaxPtr a, ...)
{
	return a;
}

cmdSyntaxPtr ps;

routine()
{
	ps = CMD_DTRUP;
	ps = CMD_DTRDN;
	ps = CMD_RTSUP;
	ps = CMD_RTSDN;
	ps = CMD_STARTFL;

					/* Set Baud Rate for transmit and receive */
	ps = CMD_SETBAUD(CBR_50);	
	ps = CMD_SETBAUD(CBR_75);	
	ps = CMD_SETBAUD(CBR_110);	
	ps = CMD_SETBAUD(CBR_134);	
	ps = CMD_SETBAUD(CBR_150);	
					/* Set Character size */
	ps = CMD_SETBITS(CSZ_5);
					/* Set number of stop bits */
	ps = CMD_SETSTOP(CST_2);	
					/* Set parity option */
	ps = CMD_SETPAR(CSP_MK);

					/* Define xon for transmitter flow control */
	ps = CMD_DEF_IXON(0x11);
					/* Define xoff for transmitter flow control */
	ps = CMD_DEF_IXOFF(0x13);

	ps = CMD_STOPFL;

	ps = r1(CMD_STOPFL, CMD_DEF_IXOFF(0x13), 
		CMD_SET_SEQ(2,3,(unsigned char *)"abc") );

					/* Acknowledge receipt of hotkey signal */
	ps = CMD_HOTACK;
					/* Define irq level to use */
	ps = CMD_SET_IRQ(CIR_10);

					/* Select transmit flow xon/xoff options */
	ps = CMD_IXON_OPT(CIX_XANY);
					/* Select receive flow xon/xoff options */
	ps = CMD_OXON_OPT(COX_XON);

	ps = CMD_CTS_REP;
	ps = CMD_CTS_NREP;
	ps = CMD_DCD_REP;
	ps = CMD_DCD_NREP;

	ps = CMD_DSR_REP;
	ps = CMD_DSR_NREP;

	ps = CMD_RI_REP;
	ps = CMD_RI_NREP;

					/* Enable break reporting and select style */
	ps = CMD_BRK_REP(CBK_STAT);

	ps = CMD_BRK_NREP;

					/* Specify maximum block size for received data */
	ps = CMD_MAX_BLOCK(64);


	ps = CMD_CTSFL_ENAB;
	ps = CMD_CTSFL_DSAB;
	ps = CMD_RTSFL_ENAB;
	ps = CMD_RTSFL_DSAB;

					/* Specify istrip option */
	ps = CMD_ISTRIP_OPT(CIS_STRIP);

	ps = CMD_SEND_BRK(20);
					/* Set error reporting mode */
	ps = CMD_SET_ERROR(CSE_MARK);

	ps = CMD_SET_SEQ(2,3,(unsigned char *)"abc");

	ps = CMD_RESUME;

					/* Set Transmit baud rate (see command 7 for arguments) */
	ps = CMD_SETBAUD_TX(CBR_9600);
					/* Set Receive baud rate (see command 7 for arguments) */
	ps = CMD_SETBAUD_RX(CBR_19200);
	ps = CMD_PING_REQ(100);
	ps = CMD_HOT_ENAB;
	ps = CMD_HOT_DSAB;
	ps = CMD_UNIX_FLAGS(1,2,3,4);
	ps = CMD_DSRFL_ENAB;
	ps = CMD_DSRFL_DSAB;
	ps = CMD_DTRFL_ENAB;
	ps = CMD_DTRFL_DSAB;
	ps = CMD_BAUD_RESET;

	ps = CMD_BAUD_REMAP(1,2);
	ps = CMD_BAUD_DEF1(3000);
	ps = CMD_BAUD_DEF2(3000);
	ps = CMD_PAUSE(250);
	ps = CMD_SUSPEND;
	ps = CMD_UNSUSPEND;
	ps = CMD_PARCHK(CPK_ENAB);
	ps = CMD_BMARK_REQ;
					/* Enable/Disable internal loopback mode */
	ps = CMD_INLOOP(CIN_ENABLE);
	ps = CMD_HOT_TIME(10);
	ps = CMD_DEF_OXON(0x91);
	ps = CMD_DEF_OXOFF(0x93);
					/* Enable/Disable RTS on transmit (1/2 duplex-style) */
	ps = CMD_RTS_XMIT(CHD_ENABLE);

	return 0;
}
