/* i2ltest.c
 * Quick test of downloading loadfiles
*/

#include "i2ellis.h"
#include "i2file.h"
#include <stdio.h>
#include "i2lib.h"
#include <dos.h>
#include <conio.h>

extern void bdump(i2eBordStrPtr);
extern void cdump(i2ChanStrPtr);


i2eBordStr myBoard;

#define NUMBER_OF_CHANNELS 16
i2ChanStr myChans[NUMBER_OF_CHANNELS];

char buffer[130];

main()
{
register i2eBordStrPtr pB = &myBoard;
int status;
int i, j;
i2ChanStrPtr pCh;
i2eBordStrPtr pBarray[4];
int amount;



#ifdef NOT_DEFINED
	status = iiSetAddress(pB, 0x308, ii2DelayIO);
#else
	status = iiSetAddress(pB, 0x308, delay);
#endif
	printf("iiSetAddress status = %x\n", status);

	status = iiReset(pB);
	printf("iiReset status = %x\n", status);
	
	status = iiResetDelay(pB);	/* 2 seconds */
	status = iiResetDelay(pB);	/* 2 seconds */

	printf("iiResetDelay status = %x\n", status);

	status = iiInitialize(pB);
	printf("iiInitialize status = %x\n", status);

	status = iiDownloadFromFile(pB, "FF.LOD", 1);
	printf("iiDownloadFile status = %x\n", status);

	status = i2InitChannels(pB, NUMBER_OF_CHANNELS, myChans);
	printf("i2InitChannels status = %x\n", status);

	pBarray[0] = pB;	
	status = i2LinkEnableIrq(1, pBarray, 15, 
				(void (far *)())i2InterruptHandler);
	printf("i2LinkEnableIrq status = %x\n", status);

	delay(1000);
	bdump(pB);
	for (i = 0, pCh = myChans; i < NUMBER_OF_CHANNELS; i++, pCh++)
	{
		printf("Channel %4x:\n", i);
		cdump(pCh);
	}

	pCh= &myChans[3];
	i2QueueCommands(PTYPE_INLINE, pCh, 1, 5,
		CMD_DCD_REP, CMD_SETBAUD(CBR_76800),
		CMD_SETBITS(CSZ_8), CMD_SETPAR(CSP_NP),
		CMD_DTRUP );
	i2QueueCommands(PTYPE_INLINE, pCh, 1, 2,
		CMD_IXON_OPT(CIX_XON), CMD_OXON_OPT(COX_XON) );

	for (i = 0; i < 10000 ;)
	{
		if (kbhit()) break;
		j = i2OutputFree(pCh);

		if(j >= 70) 
		{
			i2Output(pCh, 
(char far *)"1234567890abcdefghij1234567890ABCDEFGHIJ1234567890\n", 51);
			i++;
		}

		amount = i2Input(pCh, (char far *)buffer, 128);
		buffer[amount] = 0;
		if (amount) printf(buffer);
	}

	for (i = 0; i < 2000; i++)
	{
		iiDelay(pB, 2);	/* to give board time to "do something" */

		amount = i2Input(pCh, (char far *)buffer, 128);
		buffer[amount] = 0;
		if (amount) printf(buffer);
	}

#define NOT_D2 1
#ifdef NOT_D2
	iiDelay(pB, 2000);
	printf("AFTERWARD\n");
	bdump(pB);
	cdump(pCh);
#endif

#ifdef NOT_DEFINED
	for (i = 0, pCh = myChans; i < NUMBER_OF_CHANNELS; i++, pCh++)
	{
		printf("Channel %4x:\n", i);
		cdump(pCh);
	}
#endif

	i2RestoreIrqs();
	return 0;
}
