//i2mode.c

#define VERSION "0.01"

//compile as:

//	bcc -w i2mode.c

//0.01 -- 4/29/91 -- first release

#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <dos.h>

typedef unsigned char uchar;

int ports[8];	//the port handles

int do_port[8] = {0, 0, 0, 0, 0, 0, 0, 0};
	//which ports to apply the parameters to

int statuses[2];	//status back from driver from ioctl input

int pass;	//pass number through the arguments
//function prototypes
void main (int, char *[]);
void one_byter (uchar, uchar);
void two_byter (uchar, uchar);
void set_port (uchar, uchar);

typedef struct {
	char *par;	//the command-line parameter
	void (*func) (uchar, uchar);	//the routine to call
	uchar par1;	//1st parameter for the function call
	uchar par2;	//2nd parameter
} ps;

ps p[] = {
	{"it000", set_port, 0, 1},
	{"it001", set_port, 1, 1},
	{"it002", set_port, 2, 1},
	{"it003", set_port, 3, 1},
	{"it004", set_port, 4, 1},
	{"it005", set_port, 5, 1},
	{"it006", set_port, 6, 1},
	{"it007", set_port, 7, 1},
	{"it*", set_port, 0, 8},
	{"+dtr", one_byter, 2, 0},
	{"-dtr", one_byter, 3, 0},
	{"+rts", one_byter, 4, 0},
	{"-rts", one_byter, 5, 0},
	{"50", two_byter, 7, 1},
	{"75", two_byter, 7, 2},
	{"110", two_byter, 7, 3},
	{"134.5", two_byter, 7, 4},
	{"150", two_byter, 7, 5},
	{"200", two_byter, 7, 6},
	{"300", two_byter, 7, 7},
	{"600", two_byter, 7, 8},
	{"1200", two_byter, 7, 9},
	{"1800", two_byter, 7, 10},
	{"2400", two_byter, 7, 11},
	{"4800", two_byter, 7, 12},
	{"9600", two_byter, 7, 13},
	{"19200", two_byter, 7, 14},
	{"38400", two_byter, 7, 15},
	{"2000", two_byter, 7, 16},
	{"3600", two_byter, 7, 17},
	{"7200", two_byter, 7, 18},
	{"56000", two_byter, 7, 19},
	{"57600", two_byter, 7, 20},
	{"64000", two_byter, 7, 21},
	{"76800", two_byter, 7, 22},
	{"115200", two_byter, 7, 23},
	{"5bits", two_byter, 8, 0},
	{"6bits", two_byter, 8, 1},
	{"7bits", two_byter, 8, 2},
	{"8bits", two_byter, 8, 3},
	{"1stop", two_byter, 9, 0},
	{"1.5stop", two_byter, 9, 1},
	{"2stop", two_byter, 9, 2},
	{"none", two_byter, 10, 0},
	{"odd", two_byter, 10, 1},
	{"even", two_byter, 10, 2},
	{"space", two_byter, 10, 3},
	{"mark", two_byter, 10, 4},
	{"noxon", two_byter, 16, 0},
	{"ixon", two_byter, 16, 1},
	{"ixany", two_byter, 16, 2},
	{"noxoff", two_byter, 17, 0},
	{"xoff", two_byter, 17, 1},
	{"ctsflow", one_byter, 30, 0},
	{"noctsflow", one_byter, 31, 0},
	{"rctsflow", one_byter, 32, 0},
	{"nortsflow", one_byter, 33, 0},
	{"istrip", two_byter, 34, 0},
	{"noistrip", two_byter, 34, 1},
	{"sendbreak", two_byter, 35, 250},
	{"in_good", two_byter, 36, 1},
	{"in_discard", two_byter, 36, 2},
	{"in_null", two_byter, 36, 3},
	{"in_three", two_byter, 36, 4},
	{"t50", two_byter, 42, 1},
	{"t75", two_byter, 42, 2},
	{"t110", two_byter, 42, 3},
	{"t134.5", two_byter, 42, 4},
	{"t150", two_byter, 42, 5},
	{"t200", two_byter, 42, 6},
	{"t300", two_byter, 42, 7},
	{"t600", two_byter, 42, 8},
	{"t1200", two_byter, 42, 9},
	{"t1800", two_byter, 42, 10},
	{"t2400", two_byter, 42, 11},
	{"t4800", two_byter, 42, 12},
	{"t9600", two_byter, 42, 13},
	{"t19200", two_byter, 42, 14},
	{"t38400", two_byter, 42, 15},
	{"t2000", two_byter, 42, 16},
	{"t3600", two_byter, 42, 17},
	{"t7200", two_byter, 42, 18},
	{"t56000", two_byter, 42, 19},
	{"t57600", two_byter, 42, 20},
	{"t64000", two_byter, 42, 21},
	{"t76800", two_byter, 42, 22},
	{"t115200", two_byter, 42, 23},
	{"r50", two_byter, 43, 1},
	{"r75", two_byter, 43, 2},
	{"r110", two_byter, 43, 3},
	{"r134.5", two_byter, 43, 4},
	{"r150", two_byter, 43, 5},
	{"r200", two_byter, 43, 6},
	{"r300", two_byter, 43, 7},
	{"r600", two_byter, 43, 8},
	{"r1200", two_byter, 43, 9},
	{"r1800", two_byter, 43, 10},
	{"r2400", two_byter, 43, 11},
	{"r4800", two_byter, 43, 12},
	{"r9600", two_byter, 43, 13},
	{"r19200", two_byter, 43, 14},
	{"r38400", two_byter, 43, 15},
	{"r2000", two_byter, 43, 16},
	{"r3600", two_byter, 43, 17},
	{"r7200", two_byter, 43, 18},
	{"r56000", two_byter, 43, 19},
	{"r57600", two_byter, 43, 20},
	{"r64000", two_byter, 43, 21},
	{"r76800", two_byter, 43, 22},
	{"r115200", two_byter, 43, 23},
	{"parchk", two_byter, 59, 0},
	{"noparchk", two_byter, 59, 1},
	{"iwait", two_byter, 255, 0},	//special codes to the driver only
	{"inowait", two_byter, 255, 1},
	{"owait", two_byter, 255, 2},
	{"onowait", two_byter, 255, 3},
	{NULL, one_byter, 255, 255}	//dummy
};

void main (argc, argv)
int argc;
char *argv[];
{
	int i;
	int m;
	int ii;
	int baddie;

	if (argc <= 1)	//just display version
	{
		printf ("   i2mode -- version %s\n", VERSION);
		exit (0);
	}

	//convert all arguments to lower case
	for (i=1; i<argc; i++)
		strlwr (argv[i]);

	//first pass just opens the ports
	//second pass does the work
	
	baddie = 0;
	for (pass=0; pass<2; pass++)
	{
		for (m=1; m<argc; m++)
		{
			i = 0;
			while (p[i].par != NULL)	//try to find a match
			{
				if (strcmp (p[i].par, argv[m]))
				{
					i++;
					continue;
				}
				//got a match -- do the command
				(*p[i].func) (p[i].par1, p[i].par2);
				break;
			}
			if (p[i].par == NULL)
			{
				printf ("\007Unrecognizable parameter %d\n", m);
				baddie = 1;
			}
		}
		if (baddie)	//don't do second pass if error
			exit (0);
	}

	delay (500);	//give the board time to execute the commands,
		// in case they affect the following statuses

	//now report status
	for (ii=0; ii<8; ii++)
	{
		if (do_port[ii] == 0)
			continue;
		i = ioctl (ports[ii], 2, statuses, 4);
		if (i != 4)
			printf ("\007Error on ioctl input %d -- port %d\n", i, ii);
		else
		{
			printf ("     IT00%c: ", ii + '0');
			if (statuses[0] & 1)
				printf ("+dcd ");
			else
				printf ("-dcd ");
			if (statuses[0] & 2)
				printf ("+cts ");
			else
				printf ("-cts ");
			if (statuses[1])
				printf ("     %d breaks received", statuses[1]);
			printf ("\n");
		}
	}
	exit (0);
}

uchar command[10];	//buffer for ioctl call

void one_byter (param1, param2)
uchar param1;
uchar param2;	//second parameter is ignored
{
	int i;
	int ii;

	if (pass == 0)	//only on second pass
		return;

	command[0] = param1;
	command[1] = param2;
	for (ii=0; ii<8; ii++)
	{
		if (do_port[ii] == 0)
			continue;
		i = ioctl (ports[ii], 3, command, 1);
		if (i != 1)
			printf ("\007     Ioctl error -- one-byter %d, port %d\n", i, ii);
	}
	return;
}

void two_byter (param1, param2)
uchar param1;
uchar param2;
{
	int i;
	int ii;

	if (pass == 0)	//only on second pass
		return;

	command[0] = param1;
	command[1] = param2;
	for (ii=0; ii<8; ii++)
	{
		if (do_port[ii] == 0)
			continue;
		i = ioctl (ports[ii], 3, command, 2);
		if (i != 2)
			printf ("\007     Ioctl error -- two-byter %d, port %d\n", i, ii);
	}
	return;
}

void set_port (param1, param2)
uchar param1;
uchar param2;
{
	int i;
	char string[6];

	if (pass == 1)	//only on first pass
		return;

	strcpy (string, "IT000");
	for (i=param1; i<param1+param2; i++)
	{
		if (do_port[i] == 1)	//don't open twice
			continue;
		do_port[i] = 1;
		string[4] = i + '0';
		ports[i] = open (string, O_RDWR);
		if (ports[i] <= 0)
		{
			printf ("\n\007Error opening device %s\n", string);
			exit (1);
		}
	}
	return;
}
