//i2out.c -- outputs continuously to all channels through the
// DOS device driver

#define VERSION "0.01"

//compile as:

//	bcc -w i2out.c

//0.01 -- 4/29/91 -- first release

#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <dos.h>
#include <conio.h>

typedef unsigned char uchar;

typedef struct {
	int port;			//handle for the device
	char string[81];	//the current output string
	int pnt;			//pointer into ostring
} cc;

cc chan[8];	//for 8 channels

char portname[] = "IT000";
	
void main (void);
void send_command (int, int, uchar, uchar);

void main ()
{
	int i, j, k;

	printf ("   i2out -- version %s\n", VERSION);

	for (i=0; i<8; i++)
	{
		//open the port
		chan[i].port = open (portname, O_WRONLY);
		if (chan[i].port <= 0)
		{
			printf ("\n\007Error opening device %s\n", portname);
			exit (1);
		}
		//set up initial string
		strcpy (chan[i].string, "0/0000000 Now is the time for all good men to come to the aid of their country..");
		chan[i].string[0] = i + '0';
		chan[i].pnt = 0;
		//send the following commands:
		send_command (chan[i].port, 1, 2, 0);	//1-byte command, assert dtr
		send_command (chan[i].port, 1, 4, 0);	//1-byte command, assert rts
		send_command (chan[i].port, 2, 0xff, 3);
			//2-byte command, output nowait (library private command)
		portname[4]++;
	}

	while (1)
	{
		if (kbhit ())	//any key kills
		{
			getch ();
			exit (0);
		}
		for (i=0; i<8; i++)
		{
			j = write (chan[i].port, &chan[i].string[chan[i].pnt],
				80 - chan[i].pnt);
			chan[i].pnt += j;
			if (chan[i].pnt >= 80)
			{

				chan[i].pnt = 0;
				for (k=8; k>=2; k--)		//bump line number
				{
					if (++chan[i].string[k] <= '9')
						break;
					chan[i].string[k] = '0';
				}
			}
		}
	}
}

uchar command_buf[10];
extern int errno;

void send_command (port, count, param1, param2)
int port;	//port handle
int count;	//how many bytes
uchar param1;	//1st parameter
uchar param2;	//possible 2nd parameter
{
	int i;

	command_buf[0] = param1;
	command_buf[1] = param2;
	i = ioctl (port, 3, command_buf, count);
	if (i != count)
		printf ("\007Error -- ioctl sent %d, driver did %d, errno = %d\n",
			count, i, errno);
	return;
}
