#include<stdio.h>

asm .386

int
biosPCIpresent()
{
	asm {
		mov ax, 0b101h;
		int 1ah;
		jc  bbpci0;
		cmp edx, 20494350h;
		jne bbpci0;
		cmp ah, 0;
		jne bbpci0;
		}
		return 1;
bbpci0:
		return 0;
}
	
int
getPCIhandle()
{
int retval;

	asm {
		mov ax, 0b102h;
		mov cx, 0291h;
		mov dx, 8e0eh;
		mov si, 0;
		int 1ah;
		jc bbpci1;
		cmp ah, 0;
		jne bbpci1;
		mov retval, bx;
	}
	return retval;
bbpci1:
	return -1;
}

int
getPCIword(int handle, int addr)
{
int retval;

	asm {
		mov ax, 0b109h;
		mov	bx, handle;
		mov di, addr;
		int 1ah;
		mov retval, cx;
	}
	return retval;
}

unsigned char
getPCIbyte(int handle, int addr)
{
unsigned char retval;

	asm {
		mov ax, 0b108h;
		mov	bx, handle;
		mov di, addr;
		int 1ah;
		mov retval, cl;
	}
	return retval;
}
		
findPCIslot(int * paddress, int * pirq)
{
int handle;

	if(handle=getPCIhandle()) == -1
	{
		return 0;	/* Did not find one of our PCI-CEX products */
	}
	/* Pay no attention to DB0, which is set to indicate
	 * the I/O space.
	 */
	*paddress = (getPCIword(handle, 0x14) & 0xfffe);
	*pirq = getPCIbyte(handle, 0x3c);
	return 1;
}

		
main(int argc, char ** argv)
{
int handle;
int i;
	if(!biosPCIpresent())
	{
		printf("PCI BIOS NOT present\n");
		return 0;
	}
	else if((handle=getPCIhandle()) == -1)
	{
		printf("Cannot find Computone PCI-CEX\n");
		return 0;
	}
	for(i = 0; i < 128; i++)
	{
		if (!(i & 0xf)) printf("\n");
		printf("%02x ", getPCIbyte(handle, i));
	}
	for(i = 0; i < 128; i += 2)
	{
		if (!(i & 0xf)) printf("\n");
		printf("%04x  ", getPCIword(handle, i));
	}
	
	return 1;
}
