page	60,132
title	(C) 1991 Computone Corporation -- regl.asm

;******************************************************************************
;*                                                                            *
;*                                                                            *
;*                                                                            *
;*                  (C) Copyright 1991 Computone Corporation                  *
;*                                                                            *
;*          Unauthorized use, duplication, or disclosure prohibited           *
;*                                                                            *
;*              This module contains PROPRIETARY INFORMATION of               *
;*                            Computone Corporation                           *
;*                   and should be treated as CONFIDENTIAL.                   *
;*                                                                            *
;*                                                                            *
;*                                                                            *
;******************************************************************************

VERSION		equ	1
REVISION	equ	0
SUBREVISION	equ	0
	;version number information

;1.0.0 -- 6/6/91 -- first edition

include lw_h1.inc


;------------------------------------
; TABLE OF MAPPER VALUES
;-----------------------------------

BOX_1234	equ	28h	; selects the last box
BOX_123		equ	8h	; selects the next-last box
BOX_12		equ	18h	; selects the next-next-last box
BOX_1		equ	10h	; selects the first box when there's four


;for LCD register
maps_lcd_4	db BOX_1 or 7
maps_lcd_3	db BOX_12 or 7
maps_lcd_2	db BOX_123 or 7
maps_lcd_1	db BOX_1234 or 7

box_count_to_lcd_offset label word
dw offset maps_lcd_1
dw offset maps_lcd_2
dw offset maps_lcd_3
dw offset maps_lcd_4

page
;-- copied from low memory (bootstrap firmware info)

product_id	db 0	; if non-expandable, indicates isa-4, isa-8

number_of_boxes	db 0
box_types	db 0	; Bit-mapped (set for 16-port box, clear for 8-port)
					; 1 << n for box n (0-3)

;other variables

npasses			dw 0
color			db 0
mapper			db 0
mapper_mask		db 1	; defaults for isa-8
mode			db 0
which_lcd		db 0


; particularly for expandable

map_lcd		dw	0

lcd_limit	db  0

even
type_and_address	dw	0	; lsb has CHANNEL_REG or GLOBAL_REG
					; msb has io_address to test.

STACKSIZE	equ	100
stacker		dw STACKSIZE dup (?)

initialization:

	cli
	cld
	mov	al,GREEN	; LED green initially
	mov	color, al
	mov	dx,LED_IRQ
	out	dx,al

	sub	ax,ax		;get low memory variables we care about
	mov	ds,ax

	GET_OPERATING_MODE
	mov	cs:mode, al

	mov	al, bprodid
	mov	cs:product_id, al

	mov	al, bnbox
	mov	cs:number_of_boxes, al

	mov	al, bcpu
	shr	al, 4
	mov	cs:box_types, al

	mov	ax,cs		;set all seg registers to the code space
	mov	ds,ax
	mov	es,ax
	mov	ss,ax
	mov	sp,offset stacker+STACKSIZE*2

	assume ds:_TEXT, cs:_TEXT

	;register diagnostic 
	;uses stack

	mov color,GREEN

	test	mode, IS_EXPANDABLE
	jnz	expandable_support

	DEAD_RED	; Cannot use with non-expandable!


page
expandable_support:

	; Figure out how many boxes we have so we know what
	; mapper values to write.

	; Based on number of boxes, initialize start of
	; the mapper table, and calculate the highest uart.
	; (similarly for pic...)

	mov	al, number_of_boxes
	mov	bl, al		; spare copy for index
	mov	lcd_limit, al

	dec	bx
	and	bx, 3
	shl	bx, 1
	mov	ax, box_count_to_lcd_offset[bx]
	mov	map_lcd, ax

	xor	al, al
	mov	which_lcd, al

new_resource:
	mov	bl, which_lcd
	xor	bh, bh
	add	bx, map_lcd
	mov	al, [bx]

	out	MAPPER, al	; select a  chip
	call	recover

expand_loop:		;-- Main passes start here --

	; Mailbox tells us which LCD to address.

	mov	dx, FIFO_CMD
	in	al, dx
	test	al, MB
	jz	same_lcd

	mov	dx, FIFO_MBX
	in	al, dx
	shr	ax, 4
	and	ax, 3
	mov	which_lcd, al

	jmp	new_resource
		
same_lcd:
	in	al, 2		; any data in?
	call	recover
	test	al, 1
	jz	no_input

	in	al, 0		; yes, data is in!
	call	recover
	mov	dx, FIFO_DATA
	out	dx, al		; output it on low half of data bus.

no_input:
	mov	dx, FIFO_CMD
	in	al, dx
	test	al, EMPT	; anything in the fifo to output?
	jnz	no_output	; no!


	in	al, 2		; any room for it?
	call	recover
	test	al, 2
	jnz	no_room		; no!

	mov	dx, FIFO_DATA
	in	al, dx		; Get data from low half of data bus
	out	0, al		; and send it to LCD
	
	cmp	al, 0ah		; was it a reset?
	jne	no_reset

	call	massive_delay

no_reset:
	call	recover

no_output:
no_room:
	jmp	expand_loop

recover proc near
	ret
endp
	
massive_delay	proc	near
	push	cx
	push	dx
	mov	dx, 100
md0:	mov	cx, 65535
md1:	call	recover
	loop	md1
	dec	dx
	jnz	md0
	pop	dx
	pop	cx
	ret
endp

include lw_h2.inc

