page	60,132
title	(C) 1997 Computone Corporation -- regt.asm

;******************************************************************************
;*                                                                            *
;*                                                                            *
;*                                                                            *
;*                  (C) Copyright 1997 Computone Corporation                  *
;*                                                                            *
;*          Unauthorized use, duplication, or disclosure prohibited           *
;*                                                                            *
;*              This module contains PROPRIETARY INFORMATION of               *
;*                            Computone Corporation                           *
;*                   and should be treated as CONFIDENTIAL.                   *
;*                                                                            *
;*                                                                            *
;*                                                                            *
;******************************************************************************

VERSION		equ	1
REVISION	equ	2
SUBREVISION	equ	1
	;version number information

;1.0.0 -- 6/6/91 -- first edition
;1.1.0 -- 1/21/97 -- Starting changes to support IntelliPort-III
;                       hardware.
;1.2.0 -- 3/06/98 -- New ARR special cases for 654.
;1.2.1 -- 6/23/99 -- Further ARR special cases (15)

include lw_h1.inc



;-----------------------------------
; Values used to return error codes
; when there is a failure
;-----------------------------------


DEVICE_1400	equ	1
	GLOBAL_REG	equ	1
	CHANNEL_REG	equ	2
DEVICE_8259	equ	2
DEVICE_80186	equ	3
DEVICE_2692	equ	4
DEVICE_MAPPER	equ	5
DEVICE_LCD	equ	6
DEVICE_654	equ	7	; NEWLY ADDED! MAKE SURE
				; THE DIAGNOSTIC CAN SUPPORT THIS!


;-------------------------------
; additional manifests for 1400
;-------------------------------

SCRL	equ	022h * 2
SCRH	equ	023h * 2
LNC		equ 024h * 2
	
io_1400_table	label byte
	db GLOBAL_REG
		db GFRCR
			db 0ffh	;mask
			db 1	;increment
			db 0	;start value
			dw 256	;number of iterations
	db GLOBAL_REG
		db CAR		;channel number bits
			db 3
			db 1
			db 0
			dw 3
	db CHANNEL_REG
		db SRER		;modem change
			db 080h
			db 080h
			db 0
			dw 2
	db CHANNEL_REG
		db SRER		;rx data
			db 010h
			db 010h
			db 0
			dw 2
	db CHANNEL_REG
		db SRER		;txrdy, txmpty, nndt
			db 7	;mask
			db 1	;increment
			db 0	;start value
			dw 8	;iterations
	db CHANNEL_REG
		db COR1		;parity type
			db 080h
			db 080h
			db 0
			dw 2
	db CHANNEL_REG
		db COR1		;parity mode
			db 060h
			db 020h
			db 0
			dw 3
	db CHANNEL_REG
		db COR1		;ignore parity
			db 010h	;mask
			db 010h	;increment
			db 0	;start value
			dw 2	;iterations
	db CHANNEL_REG
		db COR1		;stop bits
			db 0ch
			db 4
			db 0
			dw 3
	db CHANNEL_REG
		db COR1		;character length
			db 3
			db 1
			db 0
			dw 4
	db CHANNEL_REG
		db COR2		;the whole thing
			db 0ffh	;mask
			db 1	;increment
			db 0	;start value
			dw 256	;iterations
	db CHANNEL_REG
		db COR2		;the whole thing -- leave it in 0 state
			db 0ffh	;mask
			db 0	;increment
			db 0	;start value
			dw 1	;iterations
	db CHANNEL_REG
		db COR3		;top 4 bits
			db 0f0h
			db 10h
			db 0
			dw 16
	db CHANNEL_REG
		db COR3		;receive threshold
			db 0fh	
			db 1
			db 1
			dw 12
	db CHANNEL_REG
		db COR4		;top 3 bits
			db 0e0h	;mask
			db 020h	;increment
			db 0	;start value
			dw 8	;iterations
	db CHANNEL_REG
		db COR4		;break bits -- 0, 1 case
			db 018h
			db 8
			db 0
			dw 2
	db CHANNEL_REG
		db COR4		;break bits -- 3 case
			db 018h
			db 1
			db 10h
			dw 1
	db CHANNEL_REG
		db COR4		;p/e/o processing
			db 7	;mask
			db 1	;increment
			db 0	;start value
			dw 5	;iterations
	db CHANNEL_REG
		db COR5		;top 3 bits
			db 0e0h
			db 020h
			db 0
			dw 8
	db CHANNEL_REG
		db COR5		;bottom 2 bits
			db 3
			db 1
			db 0
			dw 4
	db CHANNEL_REG
		db SCHR1	;spcecial char register
			db 0ffh	;mask
			db 1	;increment
			db 0	;start value
			dw 256	;iterations
	db CHANNEL_REG
		db SCHR2	;spcecial char register
			db 0ffh	;mask
			db 1	;increment
			db 0	;start value
			dw 256	;iterations
	db CHANNEL_REG
		db SCHR3	;spcecial char register
			db 0ffh	;mask
			db 1	;increment
			db 0	;start value
			dw 256	;iterations
	db CHANNEL_REG
		db SCHR4	;spcecial char register
			db 0ffh	;mask
			db 1	;increment
			db 0	;start value
			dw 256	;iterations
	db CHANNEL_REG
		db SCRL		;spcecial char register
			db 0ffh	;mask
			db 1	;increment
			db 0	;start value
			dw 256	;iterations
	db CHANNEL_REG
		db SCRH		;spcecial char register
			db 0ffh	;mask
			db 1	;increment
			db 0	;start value
			dw 256	;iterations
	db CHANNEL_REG
		db LNC		;spcecial char register
			db 0ffh	;mask
			db 1	;increment
			db 0	;start value
			dw 256	;iterations
	db CHANNEL_REG
		db MCOR1	;top 4 bits
			db 0f0h
			db 010h
			db 0
			dw 16
	db CHANNEL_REG
		db MCOR1	;bottom 4 bits
			db 0fh
			db 1
			db 0
			dw 13
	db CHANNEL_REG
		db MCOR2	;top 4 bits
			db 0f0h	;mask
			db 010h	;increment
			db 0	;start value
			dw 16	;iterations
	db CHANNEL_REG
		db RTPR		;receive time-out
			db 0ffh
			db 1
			db 0
			dw 256
	db CHANNEL_REG
		db MSVR1	;rts
			db 1
			db 1
			db 0
			dw 2
	db CHANNEL_REG
		db MSVR2	;dtr
			db 2	;mask
			db 2	;increment
			db 0	;start value
			dw 2	;iterations
	db CHANNEL_REG
		db RBPR		;receive baud rate
			db 0ffh
			db 1
			db 0
			dw 256
	db CHANNEL_REG
		db RCOR		;receive clock
			db 7
			db 1
			db 0
			dw 5
	db CHANNEL_REG
		db TBPR		;transmit baud rate
			db 0ffh	;mask
			db 1	;increment
			db 0	;start value
			dw 256	;end value
	db CHANNEL_REG
		db TCOR		;transmit clock
			db 7
			db 1
			db 0
			dw 5
	db 0
	
page

io_186_word_table	label word
dw	TMR0MODE	
	dw	31		; iterations
	dw	1fh		; mask
	dw	1		; increment
	dw	0		; initial value
dw	TMR1MODE	
	dw	31		; iterations
	dw	1fh		; mask
	dw	1		; increment
	dw	0		; initial value
dw	TMR2MODE	
	dw	2		; iterations
	dw	1h		; mask
	dw	1		; increment
	dw	0		; initial value
dw	TMR0COUNT	
	dw	0fffeh	; iterations
	dw	0ffffh	; mask
	dw	1111h	; increment
	dw	2222h	; initial value
dw	TMR1COUNT	
	dw	0fffeh	; iterations
	dw	0ffffh	; mask
	dw	1111h	; increment
	dw	2222h	; initial value
dw	TMR2COUNT	
	dw	0fffeh	; iterations
	dw	0ffffh	; mask
	dw	1111h	; increment
	dw	2222h	; initial value

dw 0			; BUMPER!

page

;------------------------------------
; TABLE OF MAPPER VALUES
;-----------------------------------

BOX_1234	equ	28h	; selects the last box
BOX_123		equ	8h	; selects the next-last box
BOX_12		equ	18h	; selects the next-next-last box
BOX_1		equ	10h	; selects the first box when there's four

; for 8259's,

maps_8259_4	db	BOX_1 or 4
maps_8259_3	db	BOX_12 or 4
maps_8259_2	db	BOX_123 or 4
maps_8259_1	db	BOX_1234 or 4

;for Async resource register

maps_resource_4	db BOX_1 or 5
maps_resource_3	db BOX_12 or 5
maps_resource_2	db BOX_123 or 5
maps_resource_1	db BOX_1234 or 5

;for LCD register
maps_lcd_4	db BOX_1 or 7
maps_lcd_3	db BOX_12 or 7
maps_lcd_2	db BOX_123 or 7
maps_lcd_1	db BOX_1234 or 7

; for 1400's, 

maps_1400_4	label	byte	; if there are 4 boxes, start here
db	BOX_1 or 0
db	BOX_1 or 1
db	BOX_1 or 2
db	BOX_1 or 3
maps_1400_3	label	byte	; if there are 3 boxes, start here
db	BOX_12 or 0
db	BOX_12 or 1
db	BOX_12 or 2
db	BOX_12 or 3
maps_1400_2	label	byte	; if there are 2 boxes, start here
db	BOX_123 or 0
db	BOX_123 or 1
db	BOX_123 or 2
db	BOX_123 or 3
maps_1400_1	label	byte	; if there is one box, start here
db	BOX_1234 or 0
db	BOX_1234 or 1
db	BOX_1234 or 2
db	BOX_1234 or 3


box_count_to_offset	label word
dw	offset maps_1400_1
dw	offset maps_1400_2
dw	offset maps_1400_3
dw	offset maps_1400_4

box_count_to_8259_offset label word
dw offset maps_8259_1
dw offset maps_8259_2
dw offset maps_8259_3
dw offset maps_8259_4

box_count_to_resource_offset label word
dw offset maps_resource_1
dw offset maps_resource_2
dw offset maps_resource_3
dw offset maps_resource_4	

box_count_to_lcd_offset label word
dw offset maps_lcd_1
dw offset maps_lcd_2
dw offset maps_lcd_3
dw offset maps_lcd_4

page
;-- copied from low memory (bootstrap firmware info)

product_id	db 0	; if non-expandable, indicates isa-4, isa-8

number_of_boxes	db 0
box_types	db 0	; Bit-mapped (set for 16-port box, clear for 8-port)
					; 1 << n for box n (0-3)
isa_cex4	db 0	; Set if this is an ISA-4 (asic)

;other variables

npasses			dw 0
color			db 0
mapper			db 0
mapper_mask		db 1	; defaults for isa-8
mode			db 0
which_1400		db 0
which_8259		db 0
which_lcd		db 0
which_resource	db 0


; particularly for expandable

map_1400	dw	0		; where does map start?
map_8259	dw	0
map_lcd		dw	0
map_resource	dw 0


base_654	dw	0	; Used by test_654...

uart_limit	db	0
pic_limit	db	0
lcd_limit	db  0
resource_limit	db 0

exists_1400	label byte	; Byte is cleared if the
				; corresponding UART is not
				; supposed to be there.
db	1, 1, 1, 1
db	1, 1, 1, 1
db 	1, 1, 1, 1
db 	1, 1, 1, 1

is_654          label   byte 	; Byte is set if the
				; corresponding UART is
				; presumed to be an ST654.
db	0, 0, 0, 0
db	0, 0, 0, 0
db	0, 0, 0, 0
db	0, 0, 0, 0

no_pic	label	byte		; Byte is set if the corresponding
				; box uses 654's, therefore wouldn't
				; use an 8259-compatible PIC
db	0, 0, 0, 0

even
type_and_address	dw	0	; lsb has CHANNEL_REG or GLOBAL_REG
					; msb has io_address to test.

STACKSIZE	equ	100
stacker		dw STACKSIZE dup (?)

initialization:

	cli
	cld
	mov	al,GREEN	; LED green initially
	mov	dx,LED_IRQ
	out	dx,al

	sub	ax,ax		;get low memory variables we care about
	mov	ds,ax

	GET_OPERATING_MODE
	mov	cs:mode, al

	mov	al, bprodid
	mov	cs:product_id, al

	mov	al, bnbox
	mov	cs:number_of_boxes, al

	mov	al, bcpu
	shr	al, 4
	mov	cs:box_types, al

	mov	al, bcpu
	and	al, 4
	mov	cs:isa_cex4, al	; Indicate if this is an ISA-4 (asic)

	mov	ax,cs		;set all seg registers to the code space
	mov	ds,ax
	mov	es,ax
	mov	ss,ax
	mov	sp,offset stacker+STACKSIZE*2

	assume ds:_TEXT, cs:_TEXT

	; Before starting the diagnostic, make sure all the timers
	; are turned off!

	mov	ax, 4000h	; if timer is off, we can read/write 
				; the counts and they don't change.
	mov	dx, TMR0MODE
	out	dx, ax
	mov	dx, TMR1MODE
	out	dx, ax
	mov	dx, TMR2MODE
	out	dx, ax

	;register diagnostic 
	;uses stack

	;first, get number of passes

	READ_DATA_WORD	mode
	mov	npasses, ax

	mov color,GREEN

	test	mode, IS_EXPANDABLE
	jz	non_expand_support
	jmp	expandable_support

page
non_expand_support:

	mov	al, product_id
	and	al, 3
	cmp	al, 3	; is it an ISA-4?
	jne	main_loop

	mov	mapper_mask, 0	; yes, so only one 1400 to check
	
main_loop:		;-- Main passes start here --

	;-- Test the 186

	call	test_186

	;-- Test all the 1400's

	mov	mapper,0
next_1400:
	mov	al, mapper
	mov	which_1400, al	; for non-expandable, happens to equal
				; the chip-mapper register.
	out	MAPPER, al	; select a (1400) chip
	jmp	short $+2	; let bus settle after write
	mov	ah, al
	in	al, MAPPER
	and	al, 1		; only one bit guaranteed to read back.
	cmp	al, ah
	jne	map_fail_1	; We should always be able to
				; read back what we wrote

	call	test_1400	; test the selected chip


	mov	al, mapper
	inc	ax
	and	al, mapper_mask
	mov	mapper, al
	test	al, al		; done with a pass?
	jnz	next_1400

	mov	dx,FIFO_DATA	; as pass completes, indicate to host
	sub	al,al
	out	dx,al		;signify to host

	dec	npasses
	jz	dead

	TOGGLE_LED color
	jmp	main_loop

dead:	jmp	dead		; once passes have completed, stop.

map_fail_1:
	jmp	map_fail

page

expandable_support:

	; Figure out how many boxes we have so we know what
	; mapper values to write.

	; initialize a table which tracks which uarts are supposed to exist.

	xor	cx, cx
	mov	cl, number_of_boxes
	mov	si, offset exists_1400
	mov	ah, box_types
	jcxz	es_2
es_1:
	mov	byte ptr [si], 1 ; for any kind of box, first two 1400's exist
	inc	si

	cmp	isa_cex4, 0	; EXCEPTION: ISA-4 (asic) has only 1 chip
	je	es_1a		; 0 = normal case

	xor	ah, ah	
	mov	byte ptr[si], ah
	jmp	es_1b

es_1a:
	mov	byte ptr [si], 1
es_1b:
	inc	si

	mov	al, ah		; let al == 1 only for 16-port box
	and	al, 1
	mov	[si], al
	inc	si
	mov	[si], al
	inc	si

	shr	ah, 1
	loop	es_1
es_2:

	; Based on number of boxes, initialize start of
	; the mapper table, and calculate the highest uart.
	; (similarly for pic...)

	mov	al, number_of_boxes
	mov	bl, al		; spare copy for index
	mov	pic_limit, al	; time 1 part per box
	mov	lcd_limit, al
	mov	resource_limit, al
	shl	al, 2		; times 4 parts per box
	mov	uart_limit, al

	dec	bx
	and	bx, 3
	shl	bx, 1
	mov	ax, box_count_to_offset[bx]
	mov	map_1400, ax
	mov	ax, box_count_to_8259_offset[bx]
	mov	map_8259, ax
	mov	ax, box_count_to_resource_offset[bx]
	mov	map_resource, ax
	mov	ax, box_count_to_lcd_offset[bx]
	mov	map_lcd, ax

	; Initialize a table which indicates whether each
	; UART is an ST654 or a CD1400
	; (does not concern itself with whether the
	; uart would be there, only what it would be if
	; it were.
	; Also initialize a table which indicates whether there
	; is a PIC or not. (The ST654 products don't use an 8259-compatible
	; PIC device).
	 
	xor	cx, cx
	mov	cl, number_of_boxes
	mov	bx, map_resource
	mov	si, offset is_654
	mov	di, offset no_pic

es_3:	mov	al, [bx]
	out	MAPPER, al	; Map in the resource register
	jmp	short $+2
	in	al, 0		; Read the resource register.

	xor	dx, dx		; assume CD1400 unless otherwise known

	cmp	al, 35h		; Any kind of PowerRack card?
	je	es_3st
	cmp	al, 34h
	je	es_3st

	; Version 1.2.0: new cases for 654
	cmp	al, 04h		; 8-port 654 non-expandable
	je	es_3st
	cmp	al, 14h		; 4-port 654 non-expandable
	je	es_3st
	cmp al, 15h		; 4-port 654 non-expand, 10-pin 
	je	es_3st	
	
	test	al, 40h		; Expandable 654's?
	jz	es_3cd		; no
	
es_3st:
	mov	dx, 0101h		; Set to indicate ST654's
es_3cd:
	mov	[di], dl		; Patch no_pic table
	inc	di 
	mov	word ptr[si], dx	; and is_654 table.
	mov	word ptr[si+2], dx
	add	si, 4
	
	inc	bx		; next box
	loop	es_3		; if it exists.
	
expand_loop:		;-- Main passes start here --


	;-- Test the 186
	; This test should be independent of the type of
	; boxes used.

	call	test_186

	;-- Test the 8259's
	; This test can only be performed on CD1400-style
	; boxes: the 654-style ones don't use 8259-compatible
	; PIC's

	xor	al, al
	jmp	test_limit_8259

next_8259:
	mov	bl, which_8259
	xor	bh, bh

	cmp	no_pic[bx], 0	; Does this box use a PIC?
	jne	skip_8259	; No, so don't even try to map it in.
				; The map values would not be valid.
	add	bx, map_8259
	mov	al, [bx]

	out	MAPPER, al	; select a (1400) chip
	jmp	short $+2	;let the bus settle after the write
	mov	ah, al
	in	al, MAPPER	; read back the mapper,
	and	al, 3fh		; this is a 6-bit register.
	cmp	al, ah
	jne	map_fail_3	; protest if not match.

	call	test_8259	; test the selected chip

skip_8259:
	mov	al, which_8259
	inc	al
test_limit_8259:
	mov	which_8259, al
	cmp	al, pic_limit
	jne	next_8259
	jmp	test_all_lcd

map_fail_3:
	jmp	map_fail
	
	;-- Test the LCD's
	; Test of whether an LCD is present is independent
	; of whether the box used CD1400's or ST654's, 
	; however it turns out that none of the ST654-style
	; boxes do.

test_all_lcd:
	xor	al, al
	jmp	test_limit_lcd

next_lcd:
	mov	bl, which_resource
	xor	bh, bh
	add	bx, map_resource
	mov	al, [bx]

	out	MAPPER, al	; select a  chip
	jmp	short $+2	;let the bus settle after the write
	mov	ah, al
	in	al, MAPPER	; read back the mapper,
	and	al, 3fh		; this is a 6-bit register.
	cmp	al, ah
	jne	map_fail_4	; protest if not match.

	in	al, 0		; read the resource register.
	test	al, 8
	jz	skip_lcd	; if bit not set, there is no LCD

	mov	bl, which_lcd
	xor	bh, bh
	add	bx, map_lcd
	mov	al, [bx]

	out	MAPPER, al	; select a  chip
	jmp	short $+2	;let the bus settle after the write
	mov	ah, al
	in	al, MAPPER	; read back the mapper,
	and	al, 3fh		; this is a 6-bit register.
	cmp	al, ah
	jne	map_fail_4	; protest if not match.

	call	test_lcd	; test the selected chip

skip_lcd:
	mov	al, which_lcd
	inc	al
test_limit_lcd:
	mov	which_lcd, al
	mov	which_resource, al
	cmp	al, lcd_limit
	jne	next_lcd
	jmp	test_1400e
	
map_fail_4:
	jmp	map_fail
	
	;-- Test all the 1400's

test_1400e:
	xor	al, al		; start with 0, if not too high!
	jmp	test_limit_1400

next_1400e:
	mov	bl, which_1400	; convert the uart number into a mapper
	xor	bh, bh
	cmp	exists_1400[bx], 0	; if the 1400 does not exist
	jz	skip_e_test		; on this box, skip

	cmp	is_654[bx], 0		; Chip exists: what kind?
	jne	doit_654		; 654? then branch before 
					; attempting to map it.
					
	add	bx, map_1400
	mov	al, [bx]		; This is valid if CD1400's are here.

	out	MAPPER, al	; select a (1400) chip
	jmp	short $+2	;let the bus settle after the write
	mov	ah, al
	in	al, MAPPER	; read back the mapper,
	and	al, 3fh		; this is a 6-bit register.
	cmp	al, ah
	jne	map_fail_2	; protest if not match.

	call	test_1400	; test the selected chip
	jmp	short skip_e_test
	
doit_654:
	; Adjust chip-mapper value so it is
	; valid for ST654's

	mov	ah, bl		; Save the chip number
	add	bx, map_1400
	mov	al, [bx]		; This is valid if CD1400's are here.
	
	and	al,  38H	; Box-selection bits only
	and	ah, 2		; select whether first two chips
	shr	ah, 1		; maps to LSB of mapper
	or	al, ah		; al now has correct mapper value

   	out	MAPPER, al	; select a (ST654) chip
	jmp	short $+2	;let the bus settle after the write
	mov	ah, al
	in	al, MAPPER	; read back the mapper,
	and	al, 3fh		; this is a 6-bit register.
	cmp	al, ah
	jne	map_fail_2	; protest if not match.
     
	; Set DX to the chip base address to use
	
	mov	dl, bl		; start with chip number
	and	dx, 1		; First, third, start at 0,
	shl	dx, 6		; Second, forth, start at 40H
	
	call	test_654	; test the selected chip.
	
skip_e_test:

	mov	al, which_1400
	inc	al
test_limit_1400:
	mov	which_1400, al
	cmp	al, uart_limit
	jne	next_1400e
	
	mov	dx,FIFO_DATA	; as pass completes, indicate to host
	sub	al,al
	out	dx,al		;signify to host

	dec	npasses
	jz	deade

	TOGGLE_LED color
	jmp	expand_loop

deade:	jmp	deade		; once passes have completed, stop.

map_fail_2:
	jmp	map_fail


map_fail:
	push	ax		; save the value read/written
	mov	dx,FIFO_DATA
	mov	al,1		;failure code
	out	dx,al
	mov	al,DEVICE_MAPPER	;chip mapper failed.
	out	dx,al
	xor	al, al
	out	dx,al		; next two not used...
	out	dx,al
	mov	al, MAPPER	; address
	out	dx,al

	pop	ax
	xchg	al, ah
	out	dx,al		; value written
	xchg	al, ah	
	out	dx,al		;value read back

	DEAD_RED
	

page

;-----------------------------------------------
; test_reg
; Helper function for test_654:
; ah = value to write,
; DX = address.
; Writes data and checks it. If it fails, it
; won't return: it will jump to t654_fail !
;-----------------------------------------------

test_reg	proc	near

	mov	al, ah
	out	dx, al
	jmp	short $+2

test_read	label	near

	in	al, dx
	cmp	al, ah
	jne	t654_fail
	ret

	nop
	nop
	nop
	nop
	nop
	nop
	
t654_fail:	; -- All failures jump to here, somehow.
	
	push	ax		; save the value read back
				; and written.
	mov	cx, dx		; Save the address.
	
	mov	dx,FIFO_DATA
	mov	al,1		;failure code
	out	dx,al
	mov	al,DEVICE_654	;1400 device
	out	dx,al
	mov	al,which_1400	; which one.
	out	dx,al
	xor	al, al
	out	dx,al		; Not used

	mov	al,cl		; Address
	out	dx,al

	pop	ax
	xchg	al, ah		;Value written now in al
	out	dx,al
	xchg	al, ah		;Value read now in al
	out	dx,al		;

	DEAD_RED

test_reg	endp
	
;------------------------------------------------------
; test_654
; Tests a single ST654, all addresses
; assumes that chip-mapper is initialized, 
; and that DX has the base address of the
; first UART on this chip.
;------------------------------------------------------

S_SCR	equ	0eh		; Relative address of scratch register.
S_LCR	equ	06h		; Relative address of LCR register
S_DLL	equ	00h		; Relative address of DLL
S_DLH	equ	02h		; Relative address of DLH
S_NEXT	equ	10h
S_EFR_VAL	equ	0bfh	; Value to write to LCR to enable EFR
S_DLAB		equ	80h	; Bit to enable DLAB
S_FCR	equ	04h		; Relative address of FCR
S_EFR	equ	04h		; Relative address of EFR
S_EFR_TEST	equ	10h	; Enable extensions
S_FCR_VAL	equ	07h	; Enable FIFO and reset.

test_654	proc	near

	mov	base_654, dx	; Save this chip's base address
	mov	cx, 4		; Test 4 UART's per chip.
	
	xor	al, al		; Clear all scratch registers
	add	dx, S_SCR
	
t654_1:
	out	dx, al
	add	dx, S_NEXT
	loop	t654_1
	
	mov	dx, base_654
	add	dx, S_SCR
	mov	cx, 4		; Walk bit through 4 registers

t654_2:
	xor	ah, ah		; Value we expect always in ah
	call	test_read

	mov	ah, 1		; Rotate a bit starting with LSB
t654_3:
	call	test_reg
	
	shl	ah, 1		; Rotate bit up one
	jnz	t654_3		; And continue as long as
				; the bit hasn't rotated out.
				
	mov	ah, 0ffh
	call	test_reg
	
	add	dx, S_NEXT	; Next UART
	loop	t654_2
	
	jmp	t654_4		; Proceed to next phase of test
	
t654_4:		; All the scratch registers seem OK.

	mov	di,base_654
	mov	cx, 4
	
t654_5:
	mov	dx, di	; Base register of this UART
	add	dx, S_LCR
	mov	al, S_EFR_VAL
	out	dx, al		; Enable the EFR register.
	
	sub	dx, S_LCR-S_EFR
	mov	ah, S_EFR_TEST
	call	test_reg	; Enable extensions, and make sure
				; the EFR can be read back.
	add	dx, S_LCR-S_EFR	; Select the LCR again
	mov	al, S_DLAB	; Enable the divisor latch
	out	dx, al
	
	sub	dx, S_LCR-S_DLL	; Select the DLL
	
	push	cx		; Push UART counter
	mov	cx, 256		; value counter
	xor	ah, ah
t654_6:
	call	test_reg	; Make sure DLL can be read back
	inc	ah
	loop	t654_6
	
	add	dx, S_DLH-S_DLL
	
	mov	cx, 256
	xor	ah, ah
t654_7:
	call	test_reg	; Make sure DLM can be read back
	inc	ah
	loop	t654_7 
	
	pop	cx	; restore chip counter
	
	add	dx, S_LCR-S_DLH	; re-select LCR
	xor	al, al
	out	dx, al		; disable DLAB
	
	sub	dx, S_LCR-S_FCR
	mov	al, S_FCR_VAL	; Write the FCR
	out	dx, al		; Note that the FCR value is different
				; from the EFR value: each has its own address

	add	dx, S_LCR-S_FCR
	mov	al, S_EFR_VAL	; Re-select EFR enabled
	out	dx, al

	sub	dx, S_LCR-S_EFR	; 
	mov	ah, S_EFR_TEST
	call	test_read	; Should be unchanged from before, even though
				; the FCR write is to the same address.
	add	dx, S_LCR-S_EFR
	xor	al, al
	out	dx, al		; Restore regular registers.
      
	add	di, S_NEXT
	loop	t654_5
	 
	ret

test_654	endp


page
;-------------------------------------------------------
; test_1400
; Tests a single uart, all addresses (see table)
; assumes that the chip mapper is properly initialized.
;-------------------------------------------------------
test_1400	proc	near

	mov	si,offset io_1400_table
	jmp	short next_1400_reg

done_1400:
	ret

next_1400_reg:
	lodsw	;al = either CHANNEL_REG, GLOBAL_REG, or 0
		;ah = address (if al ain't 0)

	test	al, al
	jz	done_1400
	
	mov	type_and_address, ax	; lsb has type, msb address.
	xchg	dx, ax		; temporarily save type in dl, address in dh
				; so ax is completely free
		
	lodsw			; mask in al, increment in ah
	xchg	di, ax		; mask in di(low), increment in di(high)

	lodsb
	mov	bh,al		;start value into bh

	lodsw
	xchg	cx, ax		; number of times, in cx

	xchg	ax, di		; mask in al, increment in ah
	mov	bl, ah		; increment in bl
	mov	ah, al		; mask into ah

	cmp	dl, CHANNEL_REG	; which kind is it? (flags valid until...)
	mov	dl, dh		;  (move address into dl)
	mov	dh, 0		;  (0-extend without touching flags)
	je	channel_1400	; ...Now!

	;-- This is a global register, then.

global_1400_loop:
	mov	al,bh		;starts at start value
	out	dx,al
	jmp	short $+2
	in	al,dx		;read it back
	and	al,ah		;mask it off
	cmp	al,bh
	jne	fail_1400
	add	bh,bl		;bump the value
	loop	global_1400_loop
	jmp	next_1400_reg 

	; -- Channel registers get tested once for each channel

channel_1400:

	mov	bp,0		;the channel counter

channel_1400_loop:
	push	ax
	mov	ax,bp
	out	CAR,al

	pop	ax		; because mask was in the ah
	mov	al,bh		;starts at start value
	out	dx,al
	jmp	short $+2
	in	al,dx		;read it back
	and	al,ah		;mask it off
	cmp	al,bh
	jne	fail_1400
	inc	bp			;now, next channel
	cmp	bp,4
	jb	channel_1400_loop
	sub	bp,bp		;start back at 0 again
	add	bh,bl		;bump the value
	loop	channel_1400_loop
	jmp	next_1400_reg 

fail_1400:
	push	ax		; save the value read back
	mov	dx,FIFO_DATA
	mov	al,1		;failure code
	out	dx,al
	mov	al,DEVICE_1400	;1400 device
	out	dx,al
	mov	al,which_1400	; which one.
	out	dx,al
	mov	ax, type_and_address
	out	dx,al
	mov	al,ah
	out	dx,al

	mov	al,bh		;value written
	out	dx,al
	pop	ax		; restore value
	out	dx,al		;value read back

	DEAD_RED
	
endp
page

;-------------------------------------------------------
; test_8259
; Tests a single pic by verifying write/read on mask register.
; assumes that the chip mapper is properly set.
;-------------------------------------------------------
test_8259	proc	near

	; We should initialize the 8259 before using

	mov	al, 00011111b	; level-trigger, single 8259, icw4 used
	out	0, al
	jmp	short $+2

	mov	al, 0		; vector
	out	2, al
	jmp	short $+2

	mov	al, 1		; vector mode
	out	2, al
	jmp	short $+2

	; The only thing we can read and write is the
	; mask register

	mov	dx, 2		; select mask register

	mov	bl, 0		; initial value
	mov	bh, 3		; increment
	mov	cx, 256		; number of iterations
pic_1:
	mov	al, bl
	out	dx, al
	jmp	short $+2
	in	al, dx
	cmp	al, bl
	jne	fail_8259

	add	bl, bh
	loop	pic_1

	mov	bl, 55h		; initial value
	mov	bh, 11h		; increment
	mov	cx, 256		; number of iterations
pic_2:
	mov	al, bl
	out	dx, al
	jmp	short $+2
	in	al, dx
	cmp	al, bl
	jne	fail_8259

	add	bl, bh
	loop	pic_2

	ret

fail_8259:
	push	ax		; save the value read back
	mov	dx,FIFO_DATA
	mov	al,1		;failure code
	out	dx,al
	mov	al,DEVICE_8259	;8259 device
	out	dx,al
	mov	al,which_8259	; which one.
	out	dx,al
	xor	ax, ax		; 0
	out	dx,al
	mov	al, 2		; always 2 (mask register)
	out	dx,al

	mov	al,bl		;value written
	out	dx,al
	pop	ax		; restore value
	out	dx,al		;value read back

	DEAD_RED
	
endp
page
;--------------------------------
; fail_lcd
; Sends a failure message to host
; and then stops with RED led
;--------------------------------

howfail db 0

fail_lcd	proc	near

	push	ax		; save the value read back
	mov	dx,FIFO_DATA
	mov	al,1		;failure code
	out	dx,al
	mov	al,DEVICE_LCD	;LCD controller
	out	dx,al
	mov	al,which_lcd	; which one.
	out	dx,al
	mov	al, howfail	; 0 = mismatch, 1 = timeout on receive,
				; 2 = timeout on transmit.
	out	dx,al
	xor	ax, ax		; address always supposed to be 0
	out	dx,al

	mov	al,bl		;value written
	out	dx,al
	pop	ax		; restore value
	out	dx,al		;value read back

	DEAD_RED
endp

page

delay_for_lcd	proc	near

	push	cx
	mov	cx, 100		; By measurement, after reading data
				; we seem to need 75 loops (= 15 uS)
				; before we can reliably read the status
				; again and not maybe read the same character
				; again.  So 100 is here for safety margin.
dfl:	loop	dfl
	pop	cx
	ret
endp

read_lcd	proc	near

	push	cx
	push	bx
	mov	bl, 1		; the bit we are looking for
	mov	cx, 100		; generally takes less than 50

r_lcd_1:
	call	delay_for_lcd	; To help prevent double-clutching
	in	al, 2
	test	al, bl		; Data available to read?
	jnz	r_lcd_2		; yes

	loop	r_lcd_1

	mov	howfail, 1	; receive timeout
	jmp	fail_lcd
	
r_lcd_2:
	pop	bx
	pop	cx		; restore registers
	in	al, 0		; Then read the data
				; (double-clutching otherwise?)
	ret
endp
write_lcd	proc	near

	push	cx
	push	bx
	push	ax
	mov	bl, 2		; the bit we are looking for
	mov	cx, 100		; Generally takes less than 50

w_lcd_1:
	call	delay_for_lcd	; To help prevent double-clutching
	in	al, 2
	test	al, bl		; Clear to write?
	jz	w_lcd_2		; yes

	loop	w_lcd_1

	mov	howfail, 2	; transmit timeout
	jmp	fail_lcd
	
w_lcd_2:
	pop	ax
	out	0, al		; restore ax and write the data
	pop	bx
	pop	cx		; restore registers
	ret
endp

page
;-------------------------------------------------------
; test_lcd
; Tests a single lcd controller interface using the
; controller's loopback command.
; assumes that the chip mapper is properly initialized.
;-------------------------------------------------------
test_string	db	1,80h,'Testing -',1fh,'Do not hit keys',2,0

multiplier	dw	0

test_lcd	proc	near

	; First, attempt to reset the LCD controller

	jmp	skip_reset	; BECAUSE OF uCONTROLLER BUG???
	mov	al, 0ah		; Reset command
	call	write_lcd	; 

	; -- How soon should it respond? 
	; -- for now, assume a normal response time...

	mov	bl, 0ah		; Wait for acknowledgement of reset
	call	read_lcd
	cmp	al, bl
	jne	fail_lcd_0

	; -- Now that reset has cleared, try to display a short
	; string...

skip_reset:
	mov	si, offset test_string
t_lcd_1:
	lodsb
	test	al, al
	jz	t_lcd_2
	mov	bl, al
	call	write_lcd
	jmp	t_lcd_1
t_lcd_2:

	mov	al, test_string+10
	call	transform
	mov	test_string+10, al

	mov	multiplier, 5
t_lcd_3:
	mov	cx, 128
	mov	bl, 10h

t_lcd_4:
	mov	al, 5	; echo command
	call	write_lcd
	mov	al, bl	; the data
	call	write_lcd

t_lcd_agin:
	call	read_lcd	; we expect d == reply to echo follows.
	cmp	al, 0dh
	jne	t_lcd_agin	; If not a reply to echo, probably a
				; key-press or something we should
				; ignore.
	
	call	read_lcd	; now get the value
	cmp	al, bl
	jne	fail_lcd_0

	inc	bx
	loop	t_lcd_4

	dec	multiplier
	jnz	t_lcd_3
	ret

fail_lcd_0:
	mov	howfail, 0	; Loopback error (character mismatch)
	jmp	fail_lcd
endp

transform	proc	near

	cmp	al, '-'
	je	tr1
	cmp	al, '/'
	je	tr2
	cmp	al, '|'
	je	tr3

tr3:	mov	al, '-'
	ret
tr2:	mov	al, '|'
	ret
tr1:	mov	al, '/'
	ret
endp

page

;-------------------------------------------------------
; test_186
; Test several peripheral registers in the 186
;-------------------------------------------------------
test_186	proc	near

	mov	si,offset io_186_word_table

next_186_word_reg:
	lodsw			; the i/o address
	test	ax, ax		;
	jz	test_186_done

	xchg	dx, ax		; store it in DX
	lodsw			; number of iterations
	xchg	cx, ax		; store in CX
	lodsw			; mask (which bits valid)
	xchg	di, ax		; store in DI
	lodsw			; increment
	xchg	bx, ax		; store in BX
	lodsw			; starting value.
	xchg	bp, ax		; store in BP

next_186_word:
	mov	ax, bp
	out	dx, ax
	jmp	short $+2
	in	ax, dx
	and	ax, di
	cmp	ax, bp
	jne	error_186
	add	bp, bx
	loop	next_186_word
	jmp	next_186_word_reg


test_186_done:
	ret


error_186:
	mov	si, ax		; save read-back value
	mov	di, dx		; save address

	mov	dx,FIFO_DATA
	mov	al,1		;failure code
	out	dx,al
	mov	al,DEVICE_80186
	out	dx,al

	mov	ax, bp		; value written
	mov	al, ah		; (MSB)
	out	dx, al

	mov	ax, si		; value read
	mov	al, ah		; (MSB)
	out	dx, ax

	mov	ax, di		; the address that failed
	out	dx, al		; (lsb of it)

	mov	ax, bp		; value written (LSB)
	out	dx, al

	mov	ax, si		; value read (LSB)
	out	dx, al

	DEAD_RED
endp 

include lw_h2.inc

