page	60,132
title	(C) 1991 Computone Corporation -- regt2.asm

;******************************************************************************
;*                                                                            *
;*                                                                            *
;*                                                                            *
;*                  (C) Copyright 1991 Computone Corporation                  *
;*                                                                            *
;*          Unauthorized use, duplication, or disclosure prohibited           *
;*                                                                            *
;*              This module contains PROPRIETARY INFORMATION of               *
;*                            Computone Corporation                           *
;*                   and should be treated as CONFIDENTIAL.                   *
;*                                                                            *
;*                                                                            *
;*                                                                            *
;******************************************************************************

;---------------------------------
; Debug-port register test.
;--------------------------------

VERSION		equ	1
REVISION	equ	0
SUBREVISION	equ	0

;-----------------------------------------------------------
; Revision History:
;
;1.0.0 -- 6/6/91 -- first edition
;1.0.1 -- 10/30/91	MAG	revised for II/IIEX support
;-----------------------------------------------------------

include lw_h1.inc

ERROR_2692	equ	4	; What to send to indicate debug-port error

;other variables

npasses			dw 0
color			db 0
mr1			dw 0
cr			dw 0
save_ax			dw 0
mode		db 0

STACKSIZE	equ	100
stacker		dw STACKSIZE dup (?)

initialization:

	cli
	cld
	mov al,GREEN	; LED green initially
	mov dx,LED_IRQ
	out dx,al

	sub	ax,ax		;get low memory variables we care about
	mov	ds,ax

	GET_OPERATING_MODE
	mov	cs:mode, al

	mov ax,cs		;set all seg registers to the code space
	mov ds,ax
	mov es,ax
	mov ss,ax
	mov sp,offset stacker+STACKSIZE*2

	;register diagnostic for 2692
	;uses stack

	;first, get number of passes

	READ_DATA_WORD	mode
	mov	npasses, ax

	mov color,RED

main_loop:
	mov mr1,D2692_MRA
	mov cr,D2692_CRA
	call test_mr1
	mov mr1,D2692_MRB
	mov cr,D2692_CRB
	call test_mr1
	mov mr1,D2692_MRA
	call test_mr2
	mov mr1,D2692_MRB
	call test_mr2

	xor color, RED
	mov al,color
	mov dx,LED_IRQ
	out dx,al

	mov dx,FIFO_DATA
	sub al,al
	out dx,al	;end of pass
	dec npasses
	jnz main_loop
	
dead:
	jmp dead

test_mr1:
	mov cx,256	;test all values
	sub ah,ah
mr1_loop:
	mov dx,cr	;issue command to point to mr1
	mov al,00010000b
	out dx,al
	jmp short $+2
	mov dx,mr1	;write the value
	mov al,ah
	out dx,al
	jmp short $+2
	mov dx,cr	;issue command to point to mr1
	mov al,00010000b
	out dx,al
	jmp short $+2
	mov dx,mr1	;read the value
	in al,dx
	cmp al,ah
	jnz mr1_fail
	add ah,19
	loop mr1_loop
	ret

mr1_fail:
	mov save_ax,ax
	mov dx,FIFO_DATA
	mov al,1	;error flag
	out dx,al
	mov al,ERROR_2692
	out dx,al
	sub al,al
	out dx,al
	out dx,al
	mov al,byte ptr mr1	;register in question
	out dx,al
	mov al,ah	;value written
	out dx,al
	mov ax,save_ax
	out dx,al	;value read back
forever:
	jmp forever

test_mr2:
	mov dx,mr1	;dummy write to get to mr2
	sub al,al
	out dx,al
	mov cx,256	;test all values
	sub ah,ah
mr2_loop:
	mov al,ah
	out dx,al
	jmp short $+2
	in al,dx
	cmp al,ah
	jnz mr2_fail
	add ah,19
	loop mr2_loop
	ret

mr2_fail:
	mov save_ax,ax
	mov dx,FIFO_DATA
	mov al,1	;error flag
	out dx,al

	mov al,ERROR_2692
	out dx,al

	sub al,al
	out dx,al

	out dx,al

	mov al,byte ptr mr1	;register in question
	inc al				; plus 1 for mr2
	out dx,al

	mov al,ah	;value written
	out dx,al
	mov ax,save_ax
	out dx,al	;value read back
forever2:
	jmp forever2

include lw_h2.inc

